<template>
  <div class="image--container">
    <div class="image--preview">
      <canvas ref="canvas" id="imageCanvas" width="300" height="300" hidden />
      <img ref="canvasImage" id="currentImage" width="300" height="300" :src="preview" alt />
      <input id="imageFile" type="file" @change="onFileChange" />
      <div class="image--select" v-if="!preview">
        <i class="fa fa-picture-o"></i>
        <span>Seleccionar imagen</span>
      </div>
    </div>
    <div v-if="preview" class="image--footer">
      <div class="rotate--buttons">
        <button @click="rotateImage(true)">
          <i class="fa fa-undo left"></i>
        </button>
        <button @click="rotateImage()">
          <i class="fa fa-undo right"></i>
        </button>
      </div>

      <button @click="onUploadImage">Subir Imagen</button>
    </div>
  </div>
</template>
<script>
import firebase from "firebase";
export default {
  name: "ImagePreview",
  props: ["imageFromGallery"],
  data() {
    return {
      canvas: null,
      context: null,
      image: null,
      preview: "",
      selectedImage: null,
      imageName: ""
    };
  },
  watch: {
    imageFromGallery: {
      immediate: true,
      handler(newVal) {
        this.$emit("upload-image", false);
        if (newVal) {
          let self = this;
          var storage = firebase.storage();
          var urlReference = storage.refFromURL(newVal);
          urlReference.getDownloadURL().then(function(url) {
            fetch(url)
              .then(response => response.blob())
              .then(data => {
                data.name = urlReference.name;
                self.preview = url;
                self.selectedImage = data;
                self.imageName = urlReference.name;
                self.setCanvasImage();
              });
          });
        }
      }
    }
  },
  mounted() {
    let vm = this;
    vm.canvas = vm.$refs.canvas;
    vm.canvas.height = 300;
    vm.canvas.width = 300;
    vm.context = vm.canvas.getContext("2d");
  },
  methods: {
    /**
     * Handle the file input and trigger a parent function
     * @param{event} e indicates the target file selected
     */
    onFileChange(e) {
      this.setCanvasImage();
      this.$emit("upload-image", false);
      this.selectedImage = e.target.files[0];
      this.preview = URL.createObjectURL(this.selectedImage);
      this.imageName = this.preview.name;
    },
    /**
     * Upload the image to firabase server and trigger a parent function to reload images
     */
    onUploadImage() {
      const storageRef = firebase
        .storage()
        .ref(`/images/${this.selectedImage.name}`)
        .put(this.selectedImage);

      storageRef.on(
        "state_changed",
        snapshot => {
          this.uploadPercent =
            (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
        },
        error => {
          console.log(error.message);
        },
        () => {
          this.uploadPercent = 100;
          this.$emit("upload-image", true);
          this.preview = "";
        }
      );
    },
    /**
     * Initialize the canvas with the image selected
     */
    setCanvasImage() {
      let self = this;
      this.image = document.getElementById("currentImage");
      this.image.onload = function() {
        self.image.setAttribute("crossorigin", "anonymous");
        self.context.drawImage(
          self.image,
          self.canvas.width / 2 - self.image.naturalWidth / 2,
          self.canvas.height / 2 - self.image.naturalHeight / 2
        );
      };
    },
    /**
     * Create the canvas context, rotate it and assign to image on blob format.
     * @param{boolean} cw indicates if rotate orientation is clockwise
     */
    rotateImage(cw = false) {
      let self = this;
      var canvas = this.canvas;
      var ctx = this.context;
      let deg = cw ? 90 : -90;
      ctx.clearRect(0, 0, canvas.width, canvas.height);
      ctx.save();
      ctx.translate(canvas.width / 2, canvas.height / 2);
      ctx.rotate((deg * Math.PI) / 180);
      ctx.drawImage(
        this.image,
        -this.image.naturalWidth / 2,
        -this.image.naturalWidth / 2
      );
      ctx.restore();
      this.preview = canvas.toDataURL();
      canvas.toBlob(function(blob) {
        blob.name = self.imageName;
        self.selectedImage = blob;
      }, 0.8);
    }
  }
};
</script>
<style lang="scss" scoped>
.image--container {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  .image--preview {
    width: 300px;
    height: 300px;
    object-fit: contain;
    background: #d3d4d9;
    border-radius: 5px;
    overflow: hidden;
    position: relative;
    display: flex;
    cursor: pointer;
    justify-content: center;
    img {
      object-fit: fill;
      width: 100%;
    }
    &:focus {
      outline: none;
    }
    .image--select {
      display: flex;
      flex-direction: column;
      color: white;
      position: absolute;
      align-self: center;
      i {
        font-size: 30px;
      }
    }
    input[type="file"] {
      cursor: pointer;
      width: 100%;
      height: 100%;
      opacity: 0;
      position: absolute;
      z-index: 2;
    }
  }
  .image--footer {
    display: flex;
    align-items: center;
    margin-top: 10px;
    .rotate--buttons {
      i {
        font-size: 18px;
      }
      .right {
        transform: rotateY(180deg);
      }
      button {
        margin: 0 5px;
        padding: 5px;
      }
    }
  }
  button {
    margin: 0 10px;
    padding: 10px;
    text-transform: uppercase;
    cursor: pointer;
    border: none;
    border: 2px solid;
    border-radius: 5px;
    background: transparent;
    color: #80b0e4;
    &:focus {
      outline: none;
    }
  }
}
</style>
